## lomiri 0.1~git20230111.ba0fc6a

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.4.0)

# Default install location. Must be set here, before setting the project.
if (NOT DEFINED CMAKE_INSTALL_PREFIX)
    set(CMAKE_INSTALL_PREFIX ${CMAKE_BINARY_DIR}/install CACHE PATH "" FORCE)
endif()

project(lomiri C CXX)

if(${PROJECT_BINARY_DIR} STREQUAL ${PROJECT_SOURCE_DIR})
   message(FATAL_ERROR "In-tree build attempt detected, aborting. Set your build dir outside your source dir, delete CMakeCache.txt from source root and try again.")
endif()

set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} ${CMAKE_CURRENT_SOURCE_DIR}/cmake/modules)

# Instruct CMake to run moc and rcc automatically when needed.
set(CMAKE_AUTOMOC ON)
set(CMAKE_AUTORCC ON)

# enable QML debugging
string(TOLOWER "${CMAKE_BUILD_TYPE}" cmake_build_type_lower) # Build types should always be lowercase but sometimes they are not.
if(cmake_build_type_lower MATCHES "debug")
    add_definitions(-DQT_QML_DEBUG)
endif()

include(EnableCoverageReport)
#####################################################################
# Enable code coverage calculation with gcov/gcovr/lcov
# Usage:
#  * Switch build type to coverage (use ccmake or cmake-gui)
#  * Invoke make, make test, make coverage (or ninja if you use that backend)
#  * Find html report in subdir coveragereport
#  * Find xml report feasible for jenkins in coverage.xml
#####################################################################
if(cmake_build_type_lower MATCHES coverage)
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} --coverage" )
  set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} --coverage" )
  set(CMAKE_MODULE_LINKER_FLAGS "${CMAKE_MODULE_LINKER_FLAGS} --coverage" )
  set(CMAKE_SHARED_LINKER_FLAGS "${CMAKE_SHARED_LINKER_FLAGS} --coverage" )
  ENABLE_COVERAGE_REPORT(TARGETS ${SHELL_APP} FILTER /usr/include ${CMAKE_SOURCE_DIR}/tests/* ${CMAKE_BINARY_DIR}/*)
endif()

find_package (ECM 1.7.0 QUIET NO_MODULE)
if (ECM_FOUND)
    # Provides us with -DECM_ENABLE_SANITIZERS='X'
    # Where X can be address, thread, memory, leak, undefined
    include("${ECM_MODULE_DIR}/ECMEnableSanitizers.cmake")
endif()

if(CMAKE_CXX_COMPILER_ID STREQUAL "GNU")
  if (NOT CMAKE_CXX_COMPILER_VERSION VERSION_LESS "5.0.0")
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wsuggest-override" )
  endif()
endif()

# Make sure we have all the needed symbols
set(CMAKE_SHARED_LINKER_FLAGS "${CMAKE_SHARED_LINKER_FLAGS} -Wl,-z,defs")
set(CMAKE_MODULE_LINKER_FLAGS "${CMAKE_MODULE_LINKER_FLAGS} -Wl,-z,defs")

# Static C++ checks
add_custom_target(cppcheck COMMAND cppcheck --enable=all -q --error-exitcode=2
                                       ${CMAKE_SOURCE_DIR}/src ${CMAKE_SOURCE_DIR}/tests)

include(FindPkgConfig)
find_package(Qt5Core 5.6 REQUIRED)
find_package(Qt5Qml 5.6 REQUIRED)
find_package(Qt5Quick 5.6 REQUIRED)
find_package(Qt5Gui 5.6 REQUIRED)
find_package(Qt5DBus 5.6 REQUIRED)
find_package(Qt5Concurrent 5.6 REQUIRED)
find_package(Qt5Sql 5.6 REQUIRED)
find_package(Qt5Test 5.6 REQUIRED)
find_package(Qt5Svg 5.6 REQUIRED)
find_package(Qt5Network 5.6 REQUIRED)
find_package(Qt5Xml 5.6 REQUIRED)

pkg_check_modules(APPLICATION_API REQUIRED lomiri-shell-application=27)
pkg_check_modules(QTMIRSERVER REQUIRED qtmirserver>=0.6.0)
pkg_check_modules(GEONAMES REQUIRED geonames>=0.2)
pkg_check_modules(GIO REQUIRED gio-2.0>=2.32)
pkg_check_modules(GLIB REQUIRED glib-2.0>=2.32)
pkg_check_modules(LAUNCHER_API REQUIRED lomiri-shell-launcher=13)
pkg_check_modules(QMENUMODEL REQUIRED qmenumodel)
pkg_check_modules(GD3 REQUIRED gnome-desktop-3.0)
pkg_check_modules(UAL REQUIRED lomiri-app-launch-0)
pkg_check_modules(LOMIRIGESTURES REQUIRED LomiriGestures)
pkg_check_modules(QTDBUSTEST REQUIRED
    libqtdbustest-1
    libqtdbusmock-1
    )
pkg_check_modules(MIRAL REQUIRED miral)
pkg_check_modules(DEVICEINFO REQUIRED deviceinfo)

### Check LomiriGestures private headers. No pkg-config (.pc) file is provided for them
find_path(LOMIRIGESTUREPRIV
    NAMES LomiriGestures/private/damper_p.h LomiriGestures/private/ucswipearea_p.h LomiriGestures/private/ucswipearea_p_p.h
    PATHS ${LOMIRIGESTURES_INCLUDEDIR}/LomiriGestures/${LOMIRIGESTURES_VERSION}
    NO_DEFAULT_PATH)
if (${LOMIRIGESTUREPRIV} STREQUAL LOMIRIGESTUREPRIV-NOTFOUND)
   message(FATAL_ERROR "LomiriGestures private headers not found.")
endif()
# end of LomiriGesture private headers check

# Standard install paths
include(GNUInstallDirs)

set(SHELL_APP_DIR ${CMAKE_INSTALL_DATADIR}/lomiri)
set(SHELL_PRIVATE_LIBDIR ${CMAKE_INSTALL_LIBDIR}/lomiri)
set(SHELL_PRIVATE_LIBEXECDIR ${CMAKE_INSTALL_LIBEXECDIR}/lomiri)

execute_process(COMMAND ${PKG_CONFIG_EXECUTABLE} --variable=plugin_private_module_dir LomiriSystemSettings OUTPUT_VARIABLE USS_PRIVATE_PLUGINDIR OUTPUT_STRIP_TRAILING_WHITESPACE)
if(USS_PRIVATE_PLUGINDIR STREQUAL "")
    message(FATAL_ERROR "Could not determine USS private plugin installation dir.")
endif()

execute_process(COMMAND ${PKG_CONFIG_EXECUTABLE} --variable=plugindir_suffix lomiri-shell-api OUTPUT_VARIABLE SHELL_INSTALL_QML OUTPUT_STRIP_TRAILING_WHITESPACE)
if(SHELL_INSTALL_QML STREQUAL "")
    message(FATAL_ERROR "Could not determine plugin installation dir.")
endif()

set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fvisibility=hidden")

execute_process(COMMAND ${PKG_CONFIG_EXECUTABLE} --variable=plugindir lomiri-shell-api OUTPUT_VARIABLE SHELL_PLUGINDIR OUTPUT_STRIP_TRAILING_WHITESPACE)
if(SHELL_PLUGINDIR STREQUAL "")
    message(FATAL_ERROR "Could not determine plugin import dir.")
endif()

set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fno-permissive -pedantic -Wall -Wextra")

set (CMAKE_CXX_STANDARD 14)

if ("${CMAKE_BUILD_TYPE}" STREQUAL "release" OR "${CMAKE_BUILD_TYPE}" STREQUAL "relwithdebinfo")
    option(Werror "Treat warnings as errors" ON)
else()
    option(Werror "Treat warnings as errors" OFF)
endif()

if (Werror)
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Werror")
endif()

# gtk and lomiri-core (actually sigc++) do not like Qt defining macros named
# "signals" and "slots"
add_definitions(-DQT_NO_KEYWORDS)

# Save a few container detach and conversions
add_definitions(-DQT_STRICT_ITERATORS)

# Use the fast string builder
add_definitions(-DQT_USE_QSTRINGBUILDER)

# Autopilot tests
include(autopilot)
declare_autopilot_test(shell lomiri.shell ${CMAKE_SOURCE_DIR}/tests/autopilot/)

set(SHELL_APP lomiri)
set(INDICATORS_CLIENT_APP indicators-client)
set(GREETER_APP lomiri-greeter)
set(MOCK_INDICATOR_SERVICE_APP lomiri-mock-indicator-service)

include_directories(
    ${CMAKE_SOURCE_DIR}/include
    ${CMAKE_BINARY_DIR}/include
    ${APPLICATION_API_INCLUDE_DIRS}
)

# Quiet logger
set(QUIET_LOGGER OFF CACHE BOOL "Disable test output on stdout.")
if(NOT QUIET_LOGGER)
    set(STDOUT_LOGGER "-o" "-,txt")
endif()

execute_process(COMMAND dpkg-architecture -qDEB_HOST_ARCH OUTPUT_VARIABLE ARCH)
if (NOT ARCH MATCHES "arm*")
    set(ENABLE_TOUCH_EMULATION true)
    add_definitions(-DLOMIRI_ENABLE_TOUCH_EMULATION)
    pkg_check_modules(MOUSETOUCHADAPTOR_LIBS REQUIRED x11 xcb xi)
else()
    set(ENABLE_TOUCH_EMULATION false)
    message(STATUS "Touch emulation support disabled.")
endif()

# add subdirectories to build
add_subdirectory(include)
add_subdirectory(src)
add_subdirectory(tools)
add_subdirectory(qml)

# Tests
set(NO_TESTS OFF CACHE BOOL "Disable tests.")
if (NOT NO_TESTS)
    include(CTest)
    enable_testing()
    add_subdirectory(tests)
else()
    message(STATUS "Tests disabled")
endif()

add_subdirectory(plugins)

#
# Data files
#
add_subdirectory(data)

#
# Translation
#
add_subdirectory(po)

#
# Documentation
#
add_subdirectory(doc)

=== data/CMakeLists.txt ===
# generate desktop files
configure_file(${SHELL_APP}.desktop.in ${CMAKE_CURRENT_BINARY_DIR}/${SHELL_APP}.desktop @ONLY)
configure_file(${INDICATORS_CLIENT_APP}.desktop.in ${CMAKE_CURRENT_BINARY_DIR}/${INDICATORS_CLIENT_APP}.desktop @ONLY)
configure_file(${GREETER_APP}.desktop.in ${CMAKE_CURRENT_BINARY_DIR}/${GREETER_APP}.desktop @ONLY)

# install desktop files
install(FILES
    ${CMAKE_CURRENT_BINARY_DIR}/${SHELL_APP}.desktop
    ${CMAKE_CURRENT_BINARY_DIR}/${INDICATORS_CLIENT_APP}.desktop
    DESTINATION ${CMAKE_INSTALL_DATADIR}/applications
    )

install(FILES
    ${CMAKE_CURRENT_BINARY_DIR}/${GREETER_APP}.desktop
    DESTINATION ${CMAKE_INSTALL_DATADIR}/lightdm/greeters
    )

install(FILES
    51-lomiri-greeter.conf
    DESTINATION ${CMAKE_INSTALL_DATADIR}/lightdm/lightdm.conf.d
    )

add_custom_target(pkgversion ALL COMMAND dpkg-parsechangelog -l${CMAKE_SOURCE_DIR}/debian/changelog --show-field version > ${CMAKE_CURRENT_BINARY_DIR}/version)

install(FILES ${CMAKE_CURRENT_BINARY_DIR}/version DESTINATION ${CMAKE_INSTALL_LOCALSTATEDIR}/lib/lomiri)

add_subdirectory(systemd-user)

=== po/CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8.9)
find_package(Gettext REQUIRED)

SET(POT_FILE
  lomiri.pot
)

FILE(GLOB PO_FILES
  *.po
)

SET(MO_FILE lomiri.mo)

FOREACH(_file ${PO_FILES})
  GET_FILENAME_COMPONENT(_lang ${_file} NAME_WE)
  SET(_gmoFile ${CMAKE_CURRENT_BINARY_DIR}/${_lang}.gmo)
  ADD_CUSTOM_COMMAND(OUTPUT ${_gmoFile}
    COMMAND ${GETTEXT_MSGFMT_EXECUTABLE} -o ${_gmoFile} ${_file}
    COMMAND install -D ${_gmoFile} ${CMAKE_CURRENT_BINARY_DIR}/locale/${_lang}/LC_MESSAGES/${MO_FILE}
    WORKING_DIRECTORY "${CMAKE_CURRENT_SOURCE_DIR}"
    DEPENDS ${_file}
  )
  INSTALL (FILES ${CMAKE_CURRENT_BINARY_DIR}/${_lang}.gmo DESTINATION ${CMAKE_INSTALL_PREFIX}/share/locale/${_lang}/LC_MESSAGES/ RENAME ${MO_FILE})
  _GETTEXT_GET_UNIQUE_TARGET_NAME( pofiles uniqueTargetName)
  ADD_CUSTOM_TARGET(${uniqueTargetName} ALL DEPENDS ${_gmoFile})
ENDFOREACH(_file)

ADD_CUSTOM_COMMAND(OUTPUT ${POT_FILE}
  COMMAND ${CMAKE_CURRENT_SOURCE_DIR}/update-lomiri-pot
)
ADD_CUSTOM_TARGET(pot_file
  DEPENDS ${POT_FILE}
)

=== data/systemd-user/CMakeLists.txt ===
pkg_get_variable(SYSTEMD_USERUNITDIR systemd systemduserunitdir)

set(MODES full-greeter full-shell greeter shell)

foreach(MODE ${MODES})
    set(CONFLICT_UNITS "")
    foreach(OTHER_MODE ${MODES})
        if(NOT ${OTHER_MODE} STREQUAL ${MODE})
            set(CONFLICT_UNITS "${CONFLICT_UNITS} lomiri-${OTHER_MODE}.service")
        endif()
    endforeach()
    string(STRIP "${CONFLICT_UNITS}" CONFLICT_UNITS)

    configure_file(
        lomiri-MODE.service.in
        ${CMAKE_CURRENT_BINARY_DIR}/lomiri-${MODE}.service
        @ONLY
    )

    install(FILES
        ${CMAKE_CURRENT_BINARY_DIR}/lomiri-${MODE}.service
        DESTINATION ${SYSTEMD_USERUNITDIR}
    )
endforeach()

install(PROGRAMS
    lomiri-systemd-wrapper
    DESTINATION ${CMAKE_INSTALL_FULL_LIBEXECDIR}
)

=== debian/changelog ===
lomiri (0.1~git20230111.ba0fc6a-5) unstable; urgency=medium

  * debian/control: Move lsc to recommends and comment it out for 
    now (closes #1029292)

 -- Marius Gripsgard <marius@ubports.com>  Sun, 22 Jan 2023 07:24:24 +0000

lomiri (0.1~git20230111.ba0fc6a-4) unstable; urgency=medium

  * Upload as is to unstable.

 -- Mike Gabriel <sunweaver@debian.org>  Fri, 13 Jan 2023 13:25:30 +0100

lomiri (0.1~git20230111.ba0fc6a-3) experimental; urgency=medium

  * debian/rules:
    + Only adjust permissions in lomiri-tests bin:pkg if it gets built. This
      resolves currently failing arch:all builds on buildd.debian.org.

 -- Mike Gabriel <sunweaver@debian.org>  Thu, 12 Jan 2023 23:51:56 +0100

lomiri (0.1~git20230111.ba0fc6a-2) experimental; urgency=medium

  * debian/lomiri-tests: Disable nonmirplugins as this does not
    work with mir2 yet

 -- Marius Gripsgard <marius@ubports.com>  Thu, 12 Jan 2023 14:43:33 +0100

lomiri (0.1~git20230111.ba0fc6a-1) experimental; urgency=medium

  * New git snapshot (0.1~git20230111.ba0fc6a)
  * debian/patches: Drop upstreamed patches
    + 0001_copyright-headers-Use-uniform-spelling-of-Canonical-.patch
    + 1001_tests-in-libexecdir.patch
    + 1002_build-doc-in-html-subdir.patch
  * debian/control: Add B-D on miroil-dev and miral-dev
  * debian/patches: Add patches to support mir v2.x
    + 0001-Add-support-for-both-older-qtmir-and-newer-qtmir-wit.patch
    + disable-broken-test-mir2.patch
  * debian/control: Bump qtmirserver-dev required version to 0.8.0~

 -- Marius Gripsgard <marius@ubports.com>  Thu, 12 Jan 2023 01:25:14 +0100

lomiri (0.1~git20221008.596f06c-1) experimental; urgency=medium

  * Initial upload to Debian experimental. (Closes: #1023253).

 -- Mike Gabriel <sunweaver@debian.org>  Sat, 05 Nov 2022 20:53:26 +0100

=== debian/control ===
Source: lomiri
Section: x11
Priority: optional
Maintainer: Debian UBports Team <team+ubports@tracker.debian.org>
Uploaders:
 Mike Gabriel <sunweaver@debian.org>,
 Marius Gripsgard <marius@ubports.com>,
Build-Depends:
 cmake,
 cmake-extras,
 dbus-test-runner,
 debhelper-compat (= 13),
 dh-apparmor,
 doxyqml,
 gdb,
 graphviz,
 lomiri-schemas,
 libdeviceinfo-dev,
 libevdev-dev,
 libgeonames-dev (>= 0.2),
 libgl1-mesa-dev[!arm64 !armhf] | libgl-dev[!arm64 !armhf],
 libgl1-mesa-dri,
 libgles2-mesa-dev[arm64 armhf],
 libglib2.0-dev,
 libgnome-desktop-3-dev,
 libgsettings-qt-dev,
 liblightdm-qt5-3-dev,
 liblomiri-connectivity-qt1-dev,
 libpam0g-dev,
 libpulse-dev,
 libqmenumodel-dev (>= 0.2.12),
 libqtmirserver-dev (>= 0.8.0~),
 libmiroil-dev,
 libmiral-dev,
 libqt5sql5-sqlite,
 libqt5svg5-dev,
 libqt5xmlpatterns5-dev,
 libqtdbusmock1-dev (>= 0.7),
 libqtdbustest1-dev,
 libsystemd-dev [linux-any],
 liblomirisystemsettings-dev,
 liblomiri-app-launch-dev,
 liblomiri-download-manager-common-dev,
 liblomirigestures-dev (>= 1.3.2030),
 liblomirigestures5-private-dev (>= 1.3.2030),
 libudev-dev,
 libldm-common-dev,
 liblomiri-api-dev,
 libusermetricsoutput-dev,
 libx11-dev[!arm64 !armhf],
 libxcb1-dev[!arm64 !armhf],
 libxi-dev[!arm64 !armhf],
 mirtest-dev,
 pkg-config,
 python3-all:any,
 python3-setuptools,
 qml-module-qt-labs-folderlistmodel,
 qml-module-qt-labs-settings,
 qml-module-qtmultimedia (>= 5.6),
 qml-module-qtqml-statemachine,
 qml-module-qtquick-layouts,
 qml-module-qtquick-xmllistmodel,
 qml-module-qtquick2,
 qml-module-qtsysteminfo,
 qml-module-qttest,
 qml-module-lomiri-components (>= 1.3.2030) | qml-module-lomiri-components-gles (>= 1.3.2030),
 qml-module-lomiri-layouts,
 qml-module-lomiri-settings-components,
 qml-module-lomiri-settings-menus,
 qml-module-lomiri-test,
 qtbase5-dev (>= 5.6),
 qtbase5-dev-tools,
 qtbase5-private-dev (>= 5.6),
 qtdbustest-runner,
 qtdeclarative5-dev (>= 5.6),
 qtdeclarative5-dev-tools,
 qtdeclarative5-private-dev (>= 5.6),
 qml-module-lomiri-content,
 systemd [linux-any],
# fonts-ubuntu,
 xvfb,
 xauth,
# mirtest pkgconfig requires these, but doesn't have a deb dependency. Bug lp:1633537
 libboost-filesystem-dev,
 libboost-system-dev,
 rdfind,
 symlinks,
Standards-Version: 4.6.1
Rules-Requires-Root: no
Homepage: https://gitlab.com/ubports/development/core/lomiri
Vcs-Git: https://salsa.debian.org/ubports-team/lomiri.git
Vcs-Browser: https://salsa.debian.org/ubports-team/lomiri

Package: lomiri-greeter
Architecture: all
Depends:
 lomiri (>= ${source:Version}), lomiri (<< ${source:Version}.1~),
 ${misc:Depends},
 ${shlibs:Depends},
Recommends:
 lightdm,
# TODO add once lsc is in
# lomiri-system-compositor,
Provides:
 lightdm-greeter,
Description: LightDM Greeter for the Lomiri Operating Environment
 Lomiri is an operating environment optimized for touch based
 human-machine interaction, but also supporting convergence (i.e.
 switching between tablet/phone and desktop mode). Lomiri is the user
 shell driving Ubuntu Touch based mobile devices.
 .
 This package provides the Lomiri Greeter.

Package: lomiri
Architecture: any
Provides:
 indicator-renderer,
 notification-daemon
Depends:
 dmz-cursor-theme,
 gsettings-desktop-schemas,
 libcap2-bin,
 libglib2.0-bin,
 qml-module-biometryd,
 qml-module-lomiri-components,
 qml-module-lomiri-layouts,
 qml-module-lomiri-settings-menus,
 qml-module-qmenumodel1,
 qml-module-qt-labs-folderlistmodel,
 qml-module-qt-labs-settings,
 qml-module-qtmir (>= 0.4.8),
 qml-module-qtqml-statemachine,
 qml-module-qtquick-xmllistmodel,
 qml-module-qtsysteminfo,
 qml-module-hfd,
# qtdeclarative5-lomiri-telephony0.1,
 qtmir,
 lomiri-system-settings (>= 0.4),
 lomiri-launcher-impl-13,
 lomiri-common (>= ${source:Version}), lomiri-common (<< ${source:Version}.1~),
 liblomiri-private0 (= ${binary:Version}),
 ${misc:Depends},
 ${shlibs:Depends},
Recommends:
 indicator-keyboard,
 indicator-session,
 lomiri-greeter-session-broadcast,
Breaks:
 indicator-network (<< 0.5.1+14.10.20141014),
 lomiri-keyboard (<< 0.100),
 lomiri-touch-session (<< 0.107),
 lomiri-scope-tool,
Replaces:
 lomiri-touch-session (<< 0.82~),
 lomiri-scope-tool,
Conflicts:
 lomiri-system-settings-wizard,
Description: Shell of the Lomiri Operating Environment
 Shell of the Lomiri Operating environment optimized for touch based
 human-machine interaction, but also supporting convergence (i.e.
 switching between tablet/phone and desktop mode). Lomiri is the user
 shell driving Ubuntu Touch based mobile devices.
 .
 This package provides the Lomiri shell.

Package: lomiri-common
Architecture: all
Depends:
 qml-module-qtquick-layouts,
 qml-module-lomiri-components (>= 1.3.2030) | qml-module-lomiri-components-gles (>= 1.3.2030),
 qml-module-lomiri-settings-components,
 qml-module-lomiri-thumbnailer,
 qtdeclarative5-lomiri-notifications-plugin (>= 0.1.2) | lomiri-notifications-impl,
 qttranslations5-l10n,
 lomiri-application-impl-27,
 lomiri-notifications-impl-3,
 lomiri-schemas,
 lomiri-tests | lomiri-application-impl,
 ${misc:Depends},
Description: Shell of the Lomiri Operating Environment (common files)
 Shell of the Lomiri Operating environment optimized for touch based
 human-machine interaction, but also supporting convergence (i.e.
 switching between tablet/phone and desktop mode). Lomiri is the user
 shell driving Ubuntu Touch based mobile devices.
 .
 This package contains the QML, graphics and locale files for lomiri.

Package: lomiri-tests
Architecture: any
Multi-Arch: foreign
Depends:
 dbus-test-runner,
 parallel,
 qtdbustest-runner,
 qtdeclarative5-dev-tools,
 lomiri (= ${binary:Version}),
 xauth,
 xvfb,
 ${misc:Depends},
 ${shlibs:Depends},
Provides:
 lomiri-application-impl,
 lomiri-application-impl-27,
 lomiri-fake-env,
Replaces:
 lomiri-autopilot (<< 8.02+15.04.20150422-0lomiri1),
 lomiri-fake-env,
Conflicts:
 lomiri-fake-env,
Description: Scripts and mocks for running Lomiri Shell tests
 Lomiri is an operating environment optimized for touch based
 human-machine interaction, but also supporting convergence (i.e.
 switching between tablet/phone and desktop mode). Lomiri is the user
 shell driving Ubuntu Touch based mobile devices.
 .
 This package provides fake implementations of some QML modules used by
 the Lomiri Shell (e.g. Lomiri.Application) so that you can run it in a
 sandboxed environment; it also provides scripts to run its test suite.

Package: liblomiri-private0
Section: libs
Architecture: any
Multi-Arch: same
Depends:
 lomiri-schemas,
 qml-module-gsettings1.0,
 qml-module-qtmultimedia,
 ${misc:Depends},
 ${shlibs:Depends},
Provides:
 lomiri-launcher-impl,
 lomiri-launcher-impl-13,
Breaks:
 lomiri-private,
Replaces:
 lomiri-private,
Description: Lomiri Operating Environment's Shell (private libs)
 Lomiri is an operating environment optimized for touch based
 human-machine interaction, but also supporting convergence (i.e.
 switching between tablet/phone and desktop mode). Lomiri is the user
 shell driving Ubuntu Touch based mobile devices.
 .
 This package contains the private libraries for QML and other components
 only used by the Lomiri Shell.

Package: lomiri-doc
Section: doc
Architecture: all
Multi-Arch: foreign
Depends:
 ${misc:Depends},
Description: Lomiri Operating Environment's Shell (documentation files)
 Lomiri is an operating environment optimized for touch based
 human-machine interaction, but also supporting convergence (i.e.
 switching between tablet/phone and desktop mode). Lomiri is the user
 shell driving Ubuntu Touch based mobile devices.
 .
 This package provides documentation of the Lomiri Shell.

=== debian/watch ===
version=4
opts="mode=git, pgpmode=none,  pretty=0.1~git%cd.%h" \
https://gitlab.com/ubports/development/core/lomiri \
HEAD debian uupdate

## lomiri 0.1

=== CMakeLists.txt ===
--- 
+++ 
@@ -5,7 +5,15 @@
     set(CMAKE_INSTALL_PREFIX ${CMAKE_BINARY_DIR}/install CACHE PATH "" FORCE)
 endif()
 
-project(lomiri C CXX)
+project(lomiri VERSION 0.1 LANGUAGES C CXX)
+
+set(SHELL_APP lomiri)
+set(INDICATORS_CLIENT_APP indicators-client)
+set(GREETER_APP lomiri-greeter)
+
+set (DESKTOP_FILE_SHELL "${SHELL_APP}.desktop")
+set (DESKTOP_FILE_GREETER "${GREETER_APP}.desktop")
+set (DESKTOP_FILE_INDICATORSCLIENT "${INDICATORS_CLIENT_APP}.desktop")
 
 if(${PROJECT_BINARY_DIR} STREQUAL ${PROJECT_SOURCE_DIR})
    message(FATAL_ERROR "In-tree build attempt detected, aborting. Set your build dir outside your source dir, delete CMakeCache.txt from source root and try again.")
@@ -74,7 +82,7 @@
 find_package(Qt5Network 5.6 REQUIRED)
 find_package(Qt5Xml 5.6 REQUIRED)
 
-pkg_check_modules(APPLICATION_API REQUIRED lomiri-shell-application=27)
+pkg_check_modules(APPLICATION_API REQUIRED lomiri-shell-application=28)
 pkg_check_modules(QTMIRSERVER REQUIRED qtmirserver>=0.6.0)
 pkg_check_modules(GEONAMES REQUIRED geonames>=0.2)
 pkg_check_modules(GIO REQUIRED gio-2.0>=2.32)
@@ -84,10 +92,6 @@
 pkg_check_modules(GD3 REQUIRED gnome-desktop-3.0)
 pkg_check_modules(UAL REQUIRED lomiri-app-launch-0)
 pkg_check_modules(LOMIRIGESTURES REQUIRED LomiriGestures)
-pkg_check_modules(QTDBUSTEST REQUIRED
-    libqtdbustest-1
-    libqtdbusmock-1
-    )
 pkg_check_modules(MIRAL REQUIRED miral)
 pkg_check_modules(DEVICEINFO REQUIRED deviceinfo)
 
@@ -153,9 +157,6 @@
 include(autopilot)
 declare_autopilot_test(shell lomiri.shell ${CMAKE_SOURCE_DIR}/tests/autopilot/)
 
-set(SHELL_APP lomiri)
-set(INDICATORS_CLIENT_APP indicators-client)
-set(GREETER_APP lomiri-greeter)
 set(MOCK_INDICATOR_SERVICE_APP lomiri-mock-indicator-service)
 
 include_directories(
@@ -189,6 +190,10 @@
 # Tests
 set(NO_TESTS OFF CACHE BOOL "Disable tests.")
 if (NOT NO_TESTS)
+    pkg_check_modules(QTDBUSTEST REQUIRED
+        libqtdbustest-1
+        libqtdbusmock-1
+        )
     include(CTest)
     enable_testing()
     add_subdirectory(tests)

=== debian/changelog ===
lomiri (0.1-2) unstable; urgency=medium

  [ Mike Gabriel ]
  * debian/control: Move lsc to recommends and comment it out for now (Closes:
    #1029292). This issue saw a regression, because upload 0.1-1 was based on
    0.1~git20230111.ba0fc6a-4 instead of 0.1~git20230111.ba0fc6a-5.
  * debian/changelog:
    + Weave-in stanza for lost 0.1~git20230111.ba0fc6a-5.
    + Amend white-space and typos of changelog item in
      0.1~git20230111.ba0fc6a-5.

 -- Mike Gabriel <sunweaver@debian.org>  Tue, 07 Feb 2023 22:33:43 +0100

lomiri (0.1-1) unstable; urgency=medium

  * Initial upstream release.
  * debian/watch:
    + Start watching upstream releases.
  * debian/copyright:
    + Update copyright attributions for debian/.
    + Update auto-generated copyright.in file.
    + Update copyright attributions.
  * debian/control:
    + Bump Standards-Version: to 4.6.2. No changes needed.
    + Bump versioned B-D of liblomiri-api-dev to (>= 0.2.0) (which implements
      lomiri-application-shell level 28 required by this version of Lomiri.
      (Closes: #1030439).

 -- Mike Gabriel <sunweaver@debian.org>  Mon, 06 Feb 2023 22:01:03 +0100

=== debian/control ===
--- 
+++ 
@@ -45,7 +45,7 @@
  liblomirigestures5-private-dev (>= 1.3.2030),
  libudev-dev,
  libldm-common-dev,
- liblomiri-api-dev,
+ liblomiri-api-dev (>= 0.2.0),
  libusermetricsoutput-dev,
  libx11-dev[!arm64 !armhf],
  libxcb1-dev[!arm64 !armhf],
@@ -63,7 +63,7 @@
  qml-module-qtquick2,
  qml-module-qtsysteminfo,
  qml-module-qttest,
- qml-module-lomiri-components (>= 1.3.2030) | qml-module-lomiri-components-gles (>= 1.3.2030),
+ qml-module-lomiri-components (>= 1.3.5000),
  qml-module-lomiri-layouts,
  qml-module-lomiri-settings-components,
  qml-module-lomiri-settings-menus,
@@ -85,7 +85,7 @@
  libboost-system-dev,
  rdfind,
  symlinks,
-Standards-Version: 4.6.1
+Standards-Version: 4.6.2
 Rules-Requires-Root: no
 Homepage: https://gitlab.com/ubports/development/core/lomiri
 Vcs-Git: https://salsa.debian.org/ubports-team/lomiri.git

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

include /usr/share/dpkg/default.mk

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1
export DPKG_GENSYMBOLS_CHECK_LEVEL=4
export NO_PNG_PKG_MANGLE=1
export QT_SELECT=qt5

export DEB_BUILD_MAINT_OPTIONS=hardening=+all
include /usr/share/dpkg/buildflags.mk

DEB_HOST_ARCH ?= $(shell dpkg-architecture -qDEB_HOST_ARCH)

# Skip tests on the archs they are known to be flaky  with current configuration
testskip_architectures := arm64 powerpc ppc64el s390x

%:
	dh $@

override_dh_missing:
	dh_missing --fail-missing

override_dh_auto_configure:
	# Debian defines CMAKE_INSTALL_LOCALSTATEDIR as /usr/var, which is wrong.
	# So until Debian bug 719148 is fixed, do it ourselves.
	dh_auto_configure -- -DCMAKE_INSTALL_LOCALSTATEDIR="/var"

override_dh_auto_build:
	# doc is not a default target
	dh_auto_build -- -O all doc

override_dh_auto_test:
	# Run the entire test battery
	# Parallel tests have a risk of starting xvfb on the same DISPLAY multiple times,
	# causing the whole battery to fail.
ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
ifneq (,$(filter $(DEB_HOST_ARCH),$(testskip_architectures)))
	-dh_auto_test --no-parallel -- -O -k xvfballtests
else
	# FIXME: Temporarily disable unit tests on all other architectures, as well. They
	# seem flaky when built+run on systems more recent than Ubuntu 20.04...
	-dh_auto_test --no-parallel -- -O -k xvfballtests
endif
endif

override_dh_fixperms:
	dh_fixperms
	[ -d debian/lomiri-tests ] && chmod a-x debian/lomiri-tests/usr/libexec/lomiri/tests/plugins/Lomiri/Session/libSessionBackendTestPreload.so || true
	[ -d debian/lomiri-tests ] && chmod a-x debian/lomiri-tests/usr/libexec/lomiri/tests/plugins/Lomiri/Launcher/applications/abs-icon.desktop || true
	[ -d debian/lomiri-tests ] && chmod a-x debian/lomiri-tests/usr/libexec/lomiri/tests/plugins/Lomiri/Launcher/applications/click-icon.desktop || true
	[ -d debian/lomiri-tests ] && chmod a-x debian/lomiri-tests/usr/libexec/lomiri/tests/plugins/Lomiri/Launcher/applications/click-icon.svg || true
	[ -d debian/lomiri-tests ] && chmod a-x debian/lomiri-tests/usr/libexec/lomiri/tests/plugins/Lomiri/Launcher/applications/no-name.desktop || true
	[ -d debian/lomiri-tests ] && chmod a-x debian/lomiri-tests/usr/libexec/lomiri/tests/plugins/Lomiri/Launcher/applications/rel-icon.desktop || true
	[ -d debian/lomiri-tests ] && chmod a-x debian/lomiri-tests/usr/libexec/lomiri/tests/plugins/Lomiri/Launcher/applications/rel-icon.svg || true

override_dh_install:
	rm debian/tmp/usr/bin/indicators-client
	rm debian/tmp/usr/share/applications/indicators-client.desktop
	rm debian/tmp/usr/share/lomiri/unlock-device
	cd debian/tmp/usr/share/doc/lomiri/html/ && rdfind -makesymlinks true .
	cd debian/tmp/usr/share/doc/lomiri/html/ && symlinks -rc .
	dh_install

# use private lib directories
override_dh_makeshlibs:
	dh_makeshlibs -Nlomiri-tests

override_dh_shlibdeps:
	# Some mock libraries link against liblightdm-qt5-3.so which we want to
	# avoid, since we only really link against our mock one, not the system one.
	dh_shlibdeps -XlibMockAccountsService-qml.so -Lliblomiri-private0

get-orig-source:
	uscan --noconf --force-download --rename --download-current-version --destdir=..

=== debian/watch ===
version=4
https://gitlab.com/ubports/development/core/lomiri/tags .*/lomiri-(\d\S+)\.tar\.gz

## lomiri 0.1.2

=== CMakeLists.txt ===
--- 
+++ 
@@ -5,7 +5,7 @@
     set(CMAKE_INSTALL_PREFIX ${CMAKE_BINARY_DIR}/install CACHE PATH "" FORCE)
 endif()
 
-project(lomiri VERSION 0.1 LANGUAGES C CXX)
+project(lomiri VERSION 0.1.2 LANGUAGES C CXX)
 
 set(SHELL_APP lomiri)
 set(INDICATORS_CLIENT_APP indicators-client)
@@ -90,10 +90,12 @@
 pkg_check_modules(LAUNCHER_API REQUIRED lomiri-shell-launcher=13)
 pkg_check_modules(QMENUMODEL REQUIRED qmenumodel)
 pkg_check_modules(GD3 REQUIRED gnome-desktop-3.0)
-pkg_check_modules(UAL REQUIRED lomiri-app-launch-0)
+# 0.1.5 adds lal-application-end.target.
+pkg_check_modules(UAL REQUIRED lomiri-app-launch-0>=0.1.5)
 pkg_check_modules(LOMIRIGESTURES REQUIRED LomiriGestures)
 pkg_check_modules(MIRAL REQUIRED miral)
 pkg_check_modules(DEVICEINFO REQUIRED deviceinfo)
+pkg_check_modules(LOMIRISCHEMA REQUIRED lomiri-schemas>=0.1.3)
 
 ### Check LomiriGestures private headers. No pkg-config (.pc) file is provided for them
 find_path(LOMIRIGESTUREPRIV

=== plugins/CMakeLists.txt ===
find_package(QmlPlugins)

# Set up and install a plugin for lomiri.
#
# add_lomiri_plugin(plugin version path
#     [...]  # See export_qmlfiles and export_qmlplugin documentation for more options
# )

macro(add_lomiri_plugin PLUGIN VERSION PATH)
    export_qmlfiles(${PLUGIN} ${PATH} DESTINATION ${SHELL_INSTALL_QML} ${ARGN})
    export_qmlplugin(${PLUGIN} ${VERSION} ${PATH} DESTINATION ${SHELL_INSTALL_QML} ${ARGN})
endmacro()

add_subdirectory(AccountsService)
add_subdirectory(Cursor)
add_subdirectory(GlobalShortcut)
add_subdirectory(Greeter)
add_subdirectory(LightDM)
add_subdirectory(Powerd)
add_subdirectory(ScreenshotDirectory)
add_subdirectory(SessionBroadcast)
add_subdirectory(Lomiri)
add_subdirectory(UInput)
add_subdirectory(Utils)
add_subdirectory(WindowManager)
add_subdirectory(Wizard)

=== qml/CMakeLists.txt ===
file(GLOB QML_JS_FILES *.qml *.js qmldir)

install(FILES ${QML_JS_FILES}
    DESTINATION ${SHELL_APP_DIR}
    )

set(QML_DIRS
    ApplicationMenus
    Components
    graphics
    Greeter
    Launcher
    Notifications
    Panel
    Stage
    Rotation
    Tutorial
    Wizard
    )

install(DIRECTORY ${QML_DIRS}
    DESTINATION ${SHELL_APP_DIR}
    )

=== src/CMakeLists.txt ===
add_subdirectory(liblomiri-private)

pkg_check_modules(CONNECTIVITY REQUIRED lomiri-connectivity-qt1)
pkg_check_modules(GSETTINGS_QT REQUIRED gsettings-qt)

include_directories(
    SYSTEM
    ${Qt5Gui_PRIVATE_INCLUDE_DIRS}
    ${Qt5Quick_PRIVATE_INCLUDE_DIRS}
    ${GSETTINGS_QT_INCLUDE_DIRS}
    ${CONNECTIVITY_INCLUDE_DIRS}
    ${QTMIRSERVER_INCLUDE_DIRS}
)

include_directories(
    ${liblomiri-private_SOURCE_DIR}
)

file(GLOB_RECURSE QML_FILES
    ${CMAKE_SOURCE_DIR}/qml/*
    ${CMAKE_SOURCE_DIR}/tests/*.qml
    ${CMAKE_SOURCE_DIR}/tests/*.js
    ${CMAKE_SOURCE_DIR}/tests/*.jpg
    ${CMAKE_SOURCE_DIR}/tests/*.png
    ${CMAKE_SOURCE_DIR}/tests/*.sci
    ${CMAKE_SOURCE_DIR}/tests/*.svg
)

set(SOURCE_FILES
    ApplicationArguments.cpp
    main.cpp
    CachingNetworkManagerFactory.cpp
    DisplayConfigurationStorage.cpp
    LomiriApplication.cpp
    LomiriCommandLineParser.cpp
    UnixSignalHandler.cpp
    DebuggingController.cpp
    WindowManagementPolicy.cpp
    ${QML_FILES} # This is to make qml and image files appear in the IDE's project tree
)

if (ENABLE_TOUCH_EMULATION)
    set(SOURCE_FILES ${SOURCE_FILES} MouseTouchAdaptor.cpp)
endif()

pkg_check_modules(SYSTEMD REQUIRED libsystemd)

include_directories(
    ${SYSTEMD_INCLUDE_DIRS}
)

add_executable(${SHELL_APP} ${SOURCE_FILES})

target_link_libraries(${SHELL_APP}
    Qt5::DBus Qt5::Gui Qt5::Qml Qt5::Quick Qt5::Test
    ${GSETTINGS_QT_LDFLAGS}
    ${QTMIRSERVER_LDFLAGS}
    ${SYSTEMD_LDFLAGS}
    LomiriGestures
    lomiri-connectivity-qt1
    lomiri-private
)

if (ENABLE_TOUCH_EMULATION)
    target_link_libraries(${SHELL_APP} ${MOUSETOUCHADAPTOR_LIBS_LDFLAGS})
endif()

# install binaries
install(TARGETS ${SHELL_APP}
     RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
     )

=== data/systemd-user/CMakeLists.txt ===
--- 
+++ 
@@ -27,3 +27,8 @@
     lomiri-systemd-wrapper
     DESTINATION ${CMAKE_INSTALL_FULL_LIBEXECDIR}
 )
+
+install(PROGRAMS
+    Xwayland.lomiri
+    DESTINATION ${CMAKE_INSTALL_FULL_LIBEXECDIR}
+)

=== plugins/Greeter/CMakeLists.txt ===
macro(add_lomiri_greeter_plugin PLUGIN VERSION PATH)
    export_qmlfiles(${PLUGIN} ${PATH} DESTINATION ${SHELL_INSTALL_QML}/Greeter TARGET_PREFIX Greeter ${ARGN})
    export_qmlplugin(${PLUGIN} ${VERSION} ${PATH} DESTINATION ${SHELL_INSTALL_QML}/Greeter TARGET_PREFIX Greeter ${ARGN})
endmacro()

add_subdirectory(Lomiri)

=== plugins/Utils/CMakeLists.txt ===
include_directories(
    ${CMAKE_CURRENT_SOURCE_DIR}
    ${CMAKE_CURRENT_BINARY_DIR}
)

include_directories(
    SYSTEM
    ${Qt5Gui_PRIVATE_INCLUDE_DIRS}
    ${Qt5Quick_PRIVATE_INCLUDE_DIRS}
    ${DEVICEINFO_INCLUDE_DIRS}
)

set(QMLPLUGIN_SRC
    activefocuslogger.cpp
    ${APPLICATION_API_INCLUDEDIR}/lomiri/shell/application/ApplicationManagerInterface.h
    ${APPLICATION_API_INCLUDEDIR}/lomiri/shell/application/ApplicationInfoInterface.h
    applicationsfiltermodel.cpp
    ${LAUNCHER_API_INCLUDEDIR}/lomiri/shell/launcher/AppDrawerModelInterface.h
    ${LAUNCHER_API_INCLUDEDIR}/lomiri/shell/launcher/LauncherItemInterface.h
    ${LAUNCHER_API_INCLUDEDIR}/lomiri/shell/launcher/LauncherModelInterface.h
    appdrawerproxymodel.cpp
    constants.cpp
    WindowInputMonitor.cpp
    inputwatcher.cpp
    qlimitproxymodelqml.cpp
    lomirisortfilterproxymodelqml.cpp
    Timer.cpp
    lomirimenumodelpaths.cpp
    windowinputfilter.cpp
    easingcurve.cpp
    windowstatestorage.cpp
    timezoneFormatter.cpp
    inputeventgenerator.cpp
    deviceconfig.cpp
    globalfunctions.cpp
    URLDispatcher.cpp
    tabfocusfence.cpp
    expressionfiltermodel.cpp
    quicklistproxymodel.cpp
    plugin.cpp
    )

add_library(Utils-qml SHARED
    ${QMLPLUGIN_SRC}
    )

target_link_libraries(Utils-qml
    Qt5::Qml Qt5::Quick Qt5::DBus Qt5::Network Qt5::Gui Qt5::Sql Qt5::Concurrent
    ${DEVICEINFO_LDFLAGS}
)

# Because this is an internal support library, we want
# to expose all symbols in it. Consider changing this
# either to a static library or just using the
# files directly in targets.
set_target_properties(Utils-qml PROPERTIES COMPILE_FLAGS -fvisibility=default)

add_lomiri_plugin(Utils 0.1 Utils TARGETS Utils-qml)

=== plugins/WindowManager/CMakeLists.txt ===
include_directories(
    SYSTEM
    ${QTMIRSERVER_INCLUDE_DIRS}
    ${Qt5Gui_PRIVATE_INCLUDE_DIRS}
)

include_directories(
    ${CMAKE_CURRENT_SOURCE_DIR}
    ${liblomiri-private_SOURCE_DIR}
)

set(WINDOWMANAGER_SRC
    AvailableDesktopArea.cpp
    TopLevelWindowModel.cpp
    Window.cpp
    WindowManagerPlugin.cpp
    WindowMargins.cpp
    Screen.cpp
    ScreenAttached.cpp
    Screens.cpp
    ScreensConfiguration.cpp
    ScreenWindow.cpp
    WindowManagerObjects.cpp
    Workspace.cpp
    WorkspaceManager.cpp
    WorkspaceModel.cpp
    InputMethodManager.cpp
    ${APPLICATION_API_INCLUDEDIR}/lomiri/shell/application/ApplicationInfoInterface.h
    ${APPLICATION_API_INCLUDEDIR}/lomiri/shell/application/ApplicationManagerInterface.h
    ${APPLICATION_API_INCLUDEDIR}/lomiri/shell/application/Mir.h
    ${APPLICATION_API_INCLUDEDIR}/lomiri/shell/application/MirSurfaceInterface.h
    ${APPLICATION_API_INCLUDEDIR}/lomiri/shell/application/MirSurfaceListInterface.h
    ${APPLICATION_API_INCLUDEDIR}/lomiri/shell/application/SurfaceManagerInterface.h
)

add_definitions(-DWINDOWMANAGERQML_LIBRARY)

add_library(windowmanager-qml SHARED ${WINDOWMANAGER_SRC})

target_link_libraries(windowmanager-qml
    Qt5::Qml Qt5::Quick Qt5::Gui
    ${QTMIRSERVER_LDFLAGS}
    lomiri-private
)

add_lomiri_plugin(WindowManager 1.0 WindowManager TARGETS windowmanager-qml)

=== plugins/Wizard/CMakeLists.txt ===
pkg_search_module(GD3 REQUIRED gnome-desktop-3.0)

include_directories(SYSTEM ${GD3_INCLUDE_DIRS} ${GLIB_INCLUDE_DIRS} ${GEONAMES_INCLUDE_DIRS})

add_library(Wizard-qml MODULE
    plugin.cpp
    PageList.cpp
    System.cpp
    LocalePlugin.cpp
    timezonemodel.cpp
    Status.cpp
    keyboardLayoutsModel.cpp
    Changelog.cpp
)

target_link_libraries(Wizard-qml
    Qt5::DBus Qt5::Qml
    ${GD3_LDFLAGS} ${GLIB_LDFLAGS} ${GEONAMES_LDFLAGS}
)
add_lomiri_plugin(Wizard 0.1 Wizard TARGETS Wizard-qml)

set(POLKIT_LIB_DIR "${CMAKE_INSTALL_LOCALSTATEDIR}/lib/polkit-1")
install(FILES 50-com.lomiri.wizard.pkla DESTINATION ${POLKIT_LIB_DIR}/localauthority/10-vendor.d)

=== tests/qmltests/CMakeLists.txt ===

add_subdirectory(Components)

add_lomiri_qmltest(. OrientedShell)
add_lomiri_qmltest(. DisabledScreenNotice)
add_lomiri_qmltest(. Shell)
add_lomiri_qmltest(. ShellWithPin)
add_lomiri_qmltest(. ShellWithPinClock)
add_lomiri_qmltest(. DeviceConfiguration)
add_lomiri_qmltest_data(. EdgeBarrierControls)
add_lomiri_qmltest_data(. ApplicationMenuDataLoader)
add_lomiri_qmltest(ApplicationMenus MenuBar)
add_lomiri_qmltest(ApplicationMenus MenuPopup)
add_lomiri_qmltest(Components Background)
add_lomiri_qmltest(Components Dialogs)
add_lomiri_qmltest(Components DraggingArea)
add_lomiri_qmltest(Components LazyImage)
add_lomiri_qmltest_data(Components tst_LazyImage)
add_lomiri_qmltest(Components Lockscreen)
add_lomiri_qmltest(Components ModeSwitchWarningDialog)
add_lomiri_qmltest(Components PhysicalKeysMapper)
add_lomiri_qmltest(Components Rating)
add_lomiri_qmltest(Components SharingPicker)
add_lomiri_qmltest(Components Showable)
add_lomiri_qmltest(Components VirtualTouchPad)
add_lomiri_qmltest(Components Wallpaper)
add_lomiri_qmltest(Components WallpaperResolver)
add_lomiri_qmltest(Components ZoomableImage)
add_lomiri_qmltest(Greeter Clock)
add_lomiri_qmltest(Greeter Greeter)
add_lomiri_qmltest(Greeter Infographics)
add_lomiri_qmltest(Greeter PinCodeClock)
add_lomiri_qmltest(Greeter NarrowView)
add_lomiri_qmltest(Greeter WideView)
add_lomiri_qmltest_data(Greeter TestView)
add_lomiri_qmltest(Launcher Launcher)
add_lomiri_qmltest(Launcher Drawer)
add_lomiri_qmltest(Notifications Notifications)
add_lomiri_qmltest(Notifications VisualSnapDecisionsQueue)
add_lomiri_qmltest(Notifications OptionToggle)
add_lomiri_qmltest(Notifications SwipeToAct)
add_lomiri_qmltest_data(Notifications Notification)
add_lomiri_qmltest(Panel ActiveCallHint)
add_lomiri_qmltest(Panel PanelItemRow)
add_lomiri_qmltest(Panel PanelMenuPage)
add_lomiri_qmltest(Panel PanelBar)
add_lomiri_qmltest(Panel PanelMenu)
add_lomiri_qmltest(Panel MenuContent)
add_lomiri_qmltest(Panel Panel)
add_lomiri_qmltest(Panel PanelSmallScreen)
add_lomiri_qmltest_data(Panel PanelTest)
add_lomiri_qmltest(Panel/Indicators IndicatorItem)
add_lomiri_qmltest(Panel/Indicators IndicatorsLight)
add_lomiri_qmltest(Panel/Indicators IndicatorMenuItemFactory)
add_lomiri_qmltest(Panel/Indicators MessageMenuItemFactory)
add_lomiri_qmltest(Stage ApplicationWindow)
add_lomiri_qmltest(Stage DesktopStage)
add_lomiri_qmltest(Stage PhoneStage)
add_lomiri_qmltest(Stage QMLTopLevelWindowModel)
add_lomiri_qmltest(Stage SurfaceContainer)
add_lomiri_qmltest(Stage TabletStage)
add_lomiri_qmltest(Stage WindowResizeArea)
add_lomiri_qmltest(Stage Splash)
add_lomiri_qmltest(Stage DecoratedWindow)
add_lomiri_qmltest(Stage WindowDecoration)
add_lomiri_qmltest_data(Stage ApplicationCheckBox)
add_lomiri_qmltest_data(Stage SizeHintField)
add_lomiri_qmltest_data(Stage SurfaceManagerControls)
add_lomiri_qmltest_data(Stage SurfaceManagerField)
add_lomiri_qmltest(Tutorial Tutorial)
add_lomiri_qmltest(Wizard Wizard ENVIRONMENT "OXIDE_NO_SANDBOX=1")
add_lomiri_qmltest_data(Wizard licenses)
#add_lomiri_qmltest_data(Wizard nolicenses)
add_lomiri_qmltest(utils/Lomiri/Test LomiriTest)
add_lomiri_qmltest_data(utils/Lomiri/Test MockObjectForInstanceOfTest)
add_lomiri_qmltest_data(utils/Lomiri/Test MockObjectForInstanceOfTestChild)

=== tests/uqmlscene/CMakeLists.txt ===
add_executable(uqmlscene
    ${shellapplication_MOC_SRCS}
    main.cpp
    ${CMAKE_SOURCE_DIR}/src/DebuggingController.cpp
    )

pkg_check_modules(XCB REQUIRED xcb)

include_directories(
    SYSTEM
    ${Qt5Quick_PRIVATE_INCLUDE_DIRS}
    ${Qt5Gui_PRIVATE_INCLUDE_DIRS}
)

include_directories(
    ${CMAKE_CURRENT_BINARY_DIR}
    ${CMAKE_SOURCE_DIR}/src
    ${CMAKE_SOURCE_DIR}/libs/LomiriGestures
    ${liblomiri-private_SOURCE_DIR}
)

if (NOT "${XCB_INCLUDE_DIRS}" STREQUAL "")
    set_target_properties(uqmlscene PROPERTIES INCLUDE_DIRECTORIES ${XCB_INCLUDE_DIRS})
endif()

target_link_libraries(uqmlscene
    Qt5::Qml Qt5::Quick Qt5::Test Qt5::DBus
    ${Qt5Qml_LIBRARIES}
    ${Qt5Quick_LIBRARIES}
    ${XCB_LDFLAGS}
    LomiriGestures
    lomiri-private
    )

install(TARGETS uqmlscene
    RUNTIME DESTINATION ${SHELL_PRIVATE_LIBEXECDIR}
    )

=== plugins/Greeter/Lomiri/CMakeLists.txt ===
add_subdirectory(Launcher)

=== debian/changelog ===
lomiri (0.1.2-4build1) mantic; urgency=medium

  * No-change rebuild against Qt 5.15.10.

 -- Dmitry Shachnev <mitya57@ubuntu.com>  Tue, 20 Jun 2023 23:52:30 +0300

lomiri (0.1.2-4) unstable; urgency=medium

  [ Marius Gripsgard ]
  * debian/*.lintian-overrides:
    + Add override for missing man pages (no need on wrappers).
  * debian/control:
    + Remove redundant recommends (we depend on it alredy).
    + Depend on libgl-dev package only.
  * debian/liblomiri-private.lintian-overrides:
    + Add lintian override for missing symbols file.

  [ Mike Gabriel ]
  * debian/patches:
    + Add 1005_cursor-always-follow-cursor-position-from-mir.patch. Keep cursor
      in Mir and in e.g. Qemu in sync.
  * debian/watch:
    + Adjust watch URL.

  [ Vagrant Cascadian ]
  * debian/rules:
    + Add dh_installdocs override to remove results.txt. (Closes: #1034200).
  * debian/patches: Add 1006_avoid-embedding-a-randomized-HOME-value.patch.
    + tests/plugins/Utils/CMakeLists.txt: Avoid embedding a randomized HOME
      value. (Closes: #1034199).

 -- Mike Gabriel <sunweaver@debian.org>  Sun, 11 Jun 2023 13:36:37 +0200

lomiri (0.1.2-3) unstable; urgency=medium

  * debian/{home.svg,lomiri-common.install}:
    + Lomiri shows the Ubuntu logo in its launcher. For a non-Ubuntu
      distribution this is inappropriate. As Lomiri has its own logo,
      ship and use that one instead.

 -- Mike Gabriel <sunweaver@debian.org>  Wed, 01 Mar 2023 08:07:12 +0100

lomiri (0.1.2-2) unstable; urgency=medium

  * debian/control:
    + Add to R (lomiri): lomiri-system-settings (this avoids MATE components
      being pulled in via Ayatana Indicators packages.

 -- Mike Gabriel <sunweaver@debian.org>  Tue, 28 Feb 2023 19:41:40 +0100

lomiri (0.1.2-1) unstable; urgency=medium

  * New upstream release.
    - systemd-user: start lal-application-end.target on stop/restart.
    - Wizard: Fix AyatanaMenuModel attributes for Wi-Fi networks.
    - Refresh Drawer desktop files when the locale changes.
    - IndicatorMenuItemFactory: use activate() for toggle switch (again).
    - Allow one to set more than 4 digits pincode.
    - Restore restarts of session services after wizard locale change.
    - Translation updates.
    - Ship & enable Xwayland wrapper.
    - plugins: TopLevelWindowModel: Explicitly cause XWayland surfaces to die
      gracefully.
    - Trim time string to remove leading space.
  * debian/patches:
    + Drop 0001-Add-support-for-both-older-qtmir-and-newer-qtmir-wit.patch.
      Applied upstream.
  * debian/control:
    + Assure presence of lomiri-schemas (>= 0.1.3) in B-D and D (various
      bin:pkgs).
    + Require lomiri-app-launch (>= 0.1.5) in B-D and D.
    + Bump versioned B-D on libqtmirserver-dev to
      (>= 0.8.0~git20230223.bd21224-3~). This pkg revisions ships an important
      adjust of the dev:pkg's .pc file.
  * debian/lomiri.install:
    + Add Xwayland.lomiri.
  * debian/copyright:
    + Update auto-generated copyright.in file.
    + Update copyright attributions.

 -- Mike Gabriel <sunweaver@debian.org>  Sun, 26 Feb 2023 18:32:05 +0100

lomiri (0.1-4) unstable; urgency=medium

  * debian/control:
    + Add to R (lomiri): maliit-keyboard.
    + Move Ayatana Indicators to D:.
    + Ensure installation of one of the Mir platforms.
    + Add to D: lomiri-indicator-network, lomiri-url-dispatcher.
    + Add to R: lomiri-indicator-transfer.

 -- Mike Gabriel <sunweaver@debian.org>  Tue, 14 Feb 2023 12:15:19 +0100

lomiri (0.1-3) unstable; urgency=medium

  * debian/control: Add back telephony as runtime dep

 -- Marius Gripsgard <marius@ubports.com>  Wed, 08 Feb 2023 03:54:13 +0100

=== debian/control ===
--- 
+++ 
@@ -14,11 +14,11 @@
  doxyqml,
  gdb,
  graphviz,
- lomiri-schemas,
+ lomiri-schemas (>= 0.1.3),
  libdeviceinfo-dev,
  libevdev-dev,
  libgeonames-dev (>= 0.2),
- libgl1-mesa-dev[!arm64 !armhf] | libgl-dev[!arm64 !armhf],
+ libgl-dev[!arm64 !armhf],
  libgl1-mesa-dri,
  libgles2-mesa-dev[arm64 armhf],
  libglib2.0-dev,
@@ -29,7 +29,7 @@
  libpam0g-dev,
  libpulse-dev,
  libqmenumodel-dev (>= 0.2.12),
- libqtmirserver-dev (>= 0.8.0~),
+ libqtmirserver-dev (>= 0.8.0~git20230223.bd21224-3~),
  libmiroil-dev,
  libmiral-dev,
  libqt5sql5-sqlite,
@@ -39,7 +39,7 @@
  libqtdbustest1-dev,
  libsystemd-dev [linux-any],
  liblomirisystemsettings-dev,
- liblomiri-app-launch-dev,
+ liblomiri-app-launch-dev (>= 0.1.5),
  liblomiri-download-manager-common-dev,
  liblomirigestures-dev (>= 1.3.2030),
  liblomirigestures5-private-dev (>= 1.3.2030),
@@ -117,6 +117,15 @@
  indicator-renderer,
  notification-daemon
 Depends:
+ ayatana-indicator-bluetooth,
+ ayatana-indicator-datetime,
+ ayatana-indicator-display,
+ ayatana-indicator-keyboard,
+ ayatana-indicator-messages,
+ ayatana-indicator-power,
+ ayatana-indicator-session,
+ ayatana-indicator-sound,
+ lomiri-app-launch (>= 0.1.5),
  dmz-cursor-theme,
  gsettings-desktop-schemas,
  libcap2-bin,
@@ -124,6 +133,7 @@
  qml-module-biometryd,
  qml-module-lomiri-components,
  qml-module-lomiri-layouts,
+ qml-module-lomiri-telephony,
  qml-module-lomiri-settings-menus,
  qml-module-qmenumodel1,
  qml-module-qt-labs-folderlistmodel,
@@ -133,18 +143,21 @@
  qml-module-qtquick-xmllistmodel,
  qml-module-qtsysteminfo,
  qml-module-hfd,
-# qtdeclarative5-lomiri-telephony0.1,
  qtmir,
+ lomiri-indicator-network,
  lomiri-system-settings (>= 0.4),
+ lomiri-url-dispatcher,
  lomiri-launcher-impl-13,
  lomiri-common (>= ${source:Version}), lomiri-common (<< ${source:Version}.1~),
  liblomiri-private0 (= ${binary:Version}),
  ${misc:Depends},
  ${shlibs:Depends},
 Recommends:
- indicator-keyboard,
- indicator-session,
+ mir-platform-graphics-gbm-kms | mir-platform-graphics-eglstream-kms | mir-platform-graphics-wayland | mir-platform-graphics-x,
+ lomiri-desktop-session | lomiri-touch-session,
  lomiri-greeter-session-broadcast,
+ lomiri-indicator-transfer,
+ maliit-keyboard,
 Breaks:
  indicator-network (<< 0.5.1+14.10.20141014),
  lomiri-keyboard (<< 0.100),
@@ -174,7 +187,7 @@
  qttranslations5-l10n,
  lomiri-application-impl-27,
  lomiri-notifications-impl-3,
- lomiri-schemas,
+ lomiri-schemas (>= 0.1.3),
  lomiri-tests | lomiri-application-impl,
  ${misc:Depends},
 Description: Shell of the Lomiri Operating Environment (common files)
@@ -222,7 +235,7 @@
 Architecture: any
 Multi-Arch: same
 Depends:
- lomiri-schemas,
+ lomiri-schemas (>= 0.1.3),
  qml-module-gsettings1.0,
  qml-module-qtmultimedia,
  ${misc:Depends},
